#include "monitor.h"

char *vidmem = (char *) 0xb8000;
unsigned int font =0x0F;

//Set Blinking cursor
void m_cursor(u32int y)
	{
	y=y*80;
	outb(0x3D4, 14);
	outb(0x3D5, y >> 8);
	outb(0x3D4, 15);
	outb(0x3D5, y);
	}

//Clear
void m_clear(void)
	{
	unsigned int i=0;
	while(i < (80*25*2))
		{
		vidmem[i]=' ';
		i++;
		vidmem[i]=0;
		i++;
		}
	}

//Scroll Screen 1 line
void m_scroll(void)
	{
	unsigned int i=0;
	while(i < (80*24*2))
		{
		vidmem[i]=vidmem[i+160];
		i++;
		}
	i=80*24*82;
	while(i < (80*25*2))
		{
		vidmem[i]=' ';
		i++;
		vidmem[i]=0;
		i++;
		}
	}

//Change Font
void m_setfont(unsigned char forecolor, unsigned char backcolor)
	{
	font = (backcolor << 4) | (forecolor & 0x0F);
	}

//Print Text
void m_text(char *message)
	{
	unsigned int i=3680;
	while(*message!=0)
		{
		if(*message=='\n')
			{			// check for a new line
			//i=25;
			*message++;
			} 
		else
			{
			vidmem[i]=*message;
			*message++;
			i++;
			vidmem[i]=font;
			i++;
			}
		}
	m_scroll();
	}

//Print Text at a position
void m_text_pos(unsigned int y, unsigned int x, char *message)
	{
	unsigned int i=0;
	i=x*2+(y*80*2);
	while(*message!=0)
		{
		if(*message=='\n')
			{			// check for a new line
			i=x*2+(y*80*2);
			*message++;
			} 
		else
			{
			vidmem[i]=*message;
			*message++;
			i++;
			vidmem[i]=font;
			i++;
			x++;
			}
		}
	}
