#include "common.h"

void outb(u16int port, u8int value)
	{
	asm volatile ("outb %1, %0" : : "dN" (port), "a" (value));
	}

u8int inb(u16int port)
	{
	u8int ret;
	asm volatile("inb %1, %0" : "=a" (ret) : "dN" (port));
	return ret;
	}

void *memset(void *dest, char val, unsigned int count)
	{
	char *temp = (char *)dest;
	for( ; count != 0; count--) *temp++ = val;
	return dest;
	}
